//
//  PriceViewController.m
//  bart
//
//  Created by Vidya on 2/26/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "PriceViewController.h"
#import "bartAppDelegate.h"
#import "SelectPriceViewController.h"

@implementation PriceViewController

@synthesize spvc; 
@synthesize destination; 
@synthesize source; 
@synthesize fare; 
@synthesize appDelegate; 
@synthesize fareValue; 
/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	appDelegate = (bartAppDelegate *)[[UIApplication sharedApplication] delegate];
	[appDelegate refreshList];
	self.navigationItem.title = @"Price of Tickets"; 
	[[self navigationController] navigationBar].barStyle = UIBarStyleBlack; 
	[[self navigationController] navigationBar].translucent = YES;
	[self setDestinationAndSource]; 
	[super viewDidLoad];
}

- (void)viewWillAppear:(BOOL)animated {
	[self setDestinationAndSource]; 
	[self findFare:self]; 
	[super viewWillAppear:animated];
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[destination release]; 
	[source release]; 
	[fare release]; 
	[spvc release]; 
	[fareValue release]; 
    [super dealloc];
}

-(void)toSelectPrice:(id)sender {
	spvc = [[SelectPriceViewController alloc] initWithNibName:@"SelectPriceViewController" bundle:[NSBundle mainBundle]]; 
	[[self navigationController] pushViewController:spvc animated:YES]; 
}

-(void)setDestinationAndSource {
	NSArray *array = [appDelegate getArrayKeys]; 
	destination.text = [array objectAtIndex:[appDelegate getPriceDestination]]; 
	source.text = [array objectAtIndex:[appDelegate getPriceSource]]; 
}

-(void)findFare:(id)sender {
	NSString *stringFirst = [[NSString alloc] initWithString:@"http://api.bart.gov/api/sched.aspx?cmd=fare&orig="];
	NSString *stringSecond = [[NSString alloc] initWithString:@"&dest="];
	NSString *stringThird = [[NSString alloc] initWithString:@"&date=today&key=MW9S-E7SL-26DU-VV8V"]; 
	
	NSArray *myArray = [appDelegate getArrayValues]; 
	NSString *berkeley = [myArray objectAtIndex:[appDelegate getPriceSource]]; 
	NSString *fremont = [myArray objectAtIndex:[appDelegate getPriceDestination]]; 
	
	NSMutableString *string = [[NSMutableString alloc] initWithString:stringFirst]; 
	[string appendString:berkeley]; 
	[string appendString:stringSecond];
	[string appendString:fremont]; 
	[string appendString:stringThird]; 
	NSURL *url = [[NSURL alloc] initWithString:string]; 
	NSXMLParser *parser = [[NSXMLParser alloc] initWithContentsOfURL:url]; 
	[parser setDelegate:self]; 
	[parser parse]; 
	NSMutableString *dollar = [[NSMutableString alloc] initWithString:@"$"];
	[dollar appendString:fareValue]; 
	fare.text = dollar; 
	
	[dollar release];
	[berkeley release];
	[fremont release]; 
	[string release]; 
	[url release]; 
	[parser release]; 
 }

- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName 
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qualifiedName attributes:(NSDictionary *)attributeDict {
	NSRange textRange;

	textRange =[elementName rangeOfString:@"fare"];
	
	if(textRange.location != NSNotFound) {
		foundFare = true;
		fareValue = [[NSMutableString alloc] init]; 
	}
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string {
	if(foundFare) {
		[fareValue appendString:string]; 
	}
}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName {
	NSRange textRange;
	
	textRange =[elementName rangeOfString:@"fare"];
	
	if(textRange.location != NSNotFound) {
		foundFare = false; 
	}
}

@end
