//
//  SelectPriceViewController.m
//  bart
//
//  Created by Vidya on 2/27/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "SelectPriceViewController.h"
#import "bartAppDelegate.h"
#import "PriceViewController.h"

@implementation SelectPriceViewController

@synthesize tableV; 
@synthesize listData; 
/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	self.navigationItem.title = @"Select Stations"; 
	appDelegate = (bartAppDelegate *)[[UIApplication sharedApplication] delegate];
	rowSelected = nil; 
	listData = [[NSArray alloc] initWithArray:[appDelegate getArrayKeys]]; 
    [super viewDidLoad];
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
	self.listData = nil; 
	rowSelected = nil; 
}


- (void)dealloc {
	[tableV release]; 
    [super dealloc];
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	return [listData count]; 
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	static NSString *SimpleTableIdentifier = @"SimpleTableIdentifier"; 
	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:SimpleTableIdentifier];
	if(cell == nil) {
		cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:SimpleTableIdentifier] autorelease]; 
	}
	
	NSUInteger row = [indexPath row]; 
	cell.textLabel.text = [listData objectAtIndex:row]; 
	cell.detailTextLabel.text = nil; 
	if(row == [appDelegate getPriceSource]) {
		cell.detailTextLabel.text = @"Current Selected Departure Station"; 
	}
	if(row == [appDelegate getPriceDestination]) {
		cell.detailTextLabel.text = @"Current Selected Destination Station";
	}
	return cell;
}

-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	NSUInteger row = [indexPath row]; 
	NSString *rowValue = [listData objectAtIndex:row]; 
	rowSelected = row; 
	NSString *message = [[NSString alloc] initWithFormat:@"You selected %@", rowValue]; 
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Row Selected"
													message:message 
												   delegate:self 
										  cancelButtonTitle:@"Cancel" 
										  otherButtonTitles:@"Set as destination station", @"Set as departure station", nil]; 
	[alert show]; 
	
	[message release]; 
	[alert release];
	tableV = tableView; 
	[tableView deselectRowAtIndexPath:indexPath animated:YES]; 
}

- (void)alertView:(UIAlertView *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex {
	// the user clicked one of the OK/Cancel buttons
	[appDelegate setPriceSelected:0]; 
	int row = 0; 
	switch (buttonIndex) {
		case 0:
			NSLog(@"cancel");
			break;
		case 1:
			NSLog(@"destination"); 
			row = 1;
			break;
		case 2:
			NSLog(@"source"); 
			row = 2;
			break;
		default:
			break;
	}
	if(rowSelected == nil) {
		row = 10; 
	}
	int rowS = rowSelected; 
	switch (row) {
		case 0:
			NSLog(@"cancel selected"); 
			break;
		case 1: 
			[appDelegate setPriceDestination:rowS];
			NSLog(@"destination selected"); 
			break;
		case 2: 
			[appDelegate setPriceSource:rowS];
			NSLog(@"source selected"); 
			break; 
		default:
			break;
	}
	rowSelected = nil; 
	if(tableV != nil) {
		[tableV reloadData];
	}
	tableV = nil; 
	[self updateDestinationAndSource]; 
}

-(void)updateDestinationAndSource {
	//int count = [[[self navigationController] viewControllers] count];
	//count = count - 2; 
	PriceViewController *controller = [[PriceViewController alloc] init];  
	[controller setDestinationAndSource]; 
}

@end
