//
//  bartAppDelegate.m
//  bart
//
//  Created by Vidya on 2/18/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "bartAppDelegate.h"


@implementation bartAppDelegate

@synthesize window;
@synthesize tabBarController;
@synthesize navigationController; 
@synthesize arrayKeys; 
@synthesize arrayValues; 
@synthesize dict;
@synthesize prefs; 

- (void)applicationDidFinishLaunching:(UIApplication *)application {
	NSLog(@"application started launching?"); 
	[window addSubview:[navigationController view]];
    [window makeKeyAndVisible];
    // Add the tab bar controller's current view as a subview of the window
    [window addSubview:tabBarController.view];
	prefs = [NSUserDefaults standardUserDefaults];
	NSInteger myIntDestination = [prefs integerForKey:@"priceDestination"];
	NSInteger myIntSource = [prefs integerForKey:@"priceSource"];
	priceDestination = myIntDestination; 
	priceSource = myIntSource; 
	NSLog(@"application finished launching"); 
}

-(void)refreshList {
	NSString *error;
	NSString *plistPath;
	NSPropertyListFormat format;
	NSString *rootPath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0]; // gets the document directory
	plistPath = [rootPath stringByAppendingPathComponent:@"data.plist"];
	if(![[NSFileManager defaultManager] fileExistsAtPath:plistPath]) {
		plistPath = [[NSBundle mainBundle] pathForResource:@"data" ofType:@"plist"];
	}
	NSData *plistXML = [[NSFileManager defaultManager] contentsAtPath:plistPath];
	NSDictionary *temp = (NSDictionary *)[NSPropertyListSerialization propertyListFromData: plistXML mutabilityOption:NSPropertyListMutableContainersAndLeaves format:&format errorDescription: &error];
	NSMutableDictionary *myPlist = [NSMutableDictionary dictionaryWithDictionary: temp]; // perhaps this is stored in an instance variable, in which case you'd want to retain it
	
	dict = [[NSDictionary alloc] initWithDictionary:[myPlist objectForKey:@"Stations"]];
	arrayKeys = [[NSArray alloc] initWithArray:[dict allKeys]]; 
	arrayValues = [[NSArray alloc] initWithArray:[dict allValues]]; 
}

/*
// Optional UITabBarControllerDelegate method
- (void)tabBarController:(UITabBarController *)tabBarController didSelectViewController:(UIViewController *)viewController {
}
*/

/*
// Optional UITabBarControllerDelegate method
- (void)tabBarController:(UITabBarController *)tabBarController didEndCustomizingViewControllers:(NSArray *)viewControllers changed:(BOOL)changed {
}
*/


- (void)dealloc {
    [tabBarController release];
    [window release];
	[navigationController release]; 
	[arrayKeys release]; 
	[arrayValues release]; 
	[dict release]; 
	[prefs release]; 
    [super dealloc];
}

-(void)setPriceDestination:(int)pd {
	priceDestination = pd; 
	[prefs setInteger:pd forKey:@"priceDestination"];
}

-(void)setPriceSource:(int)ps {
	priceSource = ps; 
	[prefs setInteger:ps forKey:@"priceSource"];
}

-(void)setPriceSelected:(int)ps {
	priceSelected = ps; 
}

-(int)getPriceSelected {
	return priceSelected;
}

-(int)getPriceSource {
	return priceSource; 
}

-(int)getPriceDestination {
	return priceDestination;
}

-(NSArray *)getArrayKeys {
	[self refreshList]; 
	return arrayKeys; 
}

-(NSArray *)getArrayValues {	[self refreshList]; 
	return arrayValues; 
}

-(NSDictionary *)getDictionary {
	[self refreshList]; 
	return dict; 
}
@end

